#!/usr/bin/env python
# -*- coding: utf-8 -*-
#####################################################################
#
#  Jan. 2010 created by Juergen Thies (juspertor UG)
#  email: juergen.thies@juspertor.com
#  This file may free use used, copied, modified or published.
#  It can also be use under any open source license like GPL, ...
#
##################################################################### 
import sys
try:
  import pylayout
  import PyQt4
except ImportError:
  import os,site
  newpath=os.environ['PATH']
  try:
    sitepack=site.getsitepackages()
    for item in sitepack:
      newpath=item+"\\layout;" +newpath
      newpath=item+";"+newpath
  except:
    print "site package path not found"
  newpath=os.getcwd()+"\\layout;"+newpath
  os.putenv("PATH",newpath)  
  import pylayout
  import PyQt4
from PyQt4 import QtCore, QtGui
from layout import *
global fileTypes 
fileTypes = {}
global fileIcons
fileIcons = {}
global fileWidget
fileWidget = {}


class iconProvider(QtGui.QFileIconProvider):
  
  def __init__(self):
    QtGui.QFileIconProvider.__init__(self)

  def type(self, fileinfo):
    if fileinfo.isFile():
      suf=fileinfo.completeSuffix()
      if fileTypes.has_key(suf.toAscii().data()):
	return fileTypes[suf.toAscii().data()]
    if fileinfo.isDir():
      fi=QtCore.QFileInfo(fileinfo.absoluteFilePath ()+"/.oalib")
      if (fi.exists()):
	return "OpenAccess"
    return QtGui.QFileIconProvider.type(self,fileinfo)

  def icon(self, fileinfo):
    if type(fileinfo)==type(QtCore.QFileInfo()):
      if fileinfo.isFile():
	suf=fileinfo.completeSuffix()
	if fileTypes.has_key(suf.toAscii().data()):
	   fType=fileTypes[suf.toAscii().data()]
	   if fileIcons.has_key(fType):
	      return fileIcons[fType]
    if fileinfo.isDir():
      fi=QtCore.QFileInfo(fileinfo.absoluteFilePath ()+"/.oalib")
      if (fi.exists()):
	return QtGui.QIcon(":/icons/accessicon.png")
    return QtGui.QFileIconProvider.icon(self,fileinfo)

#################################################################################
#
# handler for openAccess
#
#################################################################################

class oaHandler(QtGui.QWidget):
  def __init__(self,libraryWindow):
    QtGui.QWidget.__init__(self)
    fileWidget['OpenAccess']=self
    self.visible=False
    self.libraryWindow=libraryWindow
    hLayout = QtGui.QHBoxLayout(self)
    self.cellList = QtGui.QListWidget(self)
    self.cellList.currentItemChanged.connect(self.cellSelected)
    hLayout.addWidget(self.cellList)
    self.viewList = QtGui.QListWidget(self)
    self.viewList.currentItemChanged.connect(self.viewSelected)
    self.libname=""
    hLayout.addWidget(self.viewList)
    hLayout.setContentsMargins(0,0,0,0)
    libraryWindow.stackedWidget.addWidget(self)

  def setFile(self,libraryWindow,fileinfo):
    if (pylayout.oaInfo.isLib(fileinfo.fileName(),fileinfo.absoluteFilePath())==False):
      return;
    self.visible=True
    libraryWindow.stackedWidget.setCurrentWidget(self)
    cl=pylayout.oaInfo.getCellNames(fileinfo.fileName())
    self.libname=fileinfo.fileName()
    self.cellList.clear();
    self.cellList.addItems(cl)
    self.viewList.clear();

  def unsetFile(self,libraryWindow):
    self.visible=False
    
  def cellSelected(self,newItem,oldItem):
    if newItem==None:
      return;
    vl=pylayout.oaInfo.getViewNames(self.libname,newItem.text())
    self.cellname=newItem.text()
    self.viewList.clear();
    self.viewList.addItems(vl)

  def viewSelected(self,newItem,oldItem):
    if newItem==None:
      return ;
    type= pylayout.oaInfo.getViewType( self.libname,self.cellname,newItem.text())
    if type=="schematic":
       if self.libraryWindow.schematicWindow.schematicClose:
            self.libraryWindow.schematicWindow.openSchematic()
       self.libraryWindow.schematicWindow.s.show()
       if self.libraryWindow.schematicWindow.s.drawing.mutexReadTryLock():
	      self.libraryWindow.schematicWindow.s.drawing.openView( self.libname,self.cellname,newItem.text())
	      self.libraryWindow.schematicWindow.s.drawing.mutexReadUnlock();
	      self.libraryWindow.schematicWindow.s.filename=self.libname+".oa"
	      self.libraryWindow.schematicWindow.s.setWindowTitle( self.libraryWindow.schematicWindow.s.filename )
	      self.libraryWindow.schematicWindow.s.drawing.paint()
       return;
    #if type=="schematicSymbol":
    #if type=="verilogText":
    #if type=="maskLayout":
    if self.libraryWindow.layoutWindow.layoutClose==True:
       self.libraryWindow.layoutWindow.openLayout("layoutFull")
    if self.libraryWindow.layoutWindow.l.drawing.modified():
	import random;
	r=random.random()
	pyLayoutNewWin[r] = self.libraryWindow.layoutWindow
	self.libraryWindow.layoutWindow = layoutWindow("layoutFull") 
    self.libraryWindow.layoutWindow.l.show()
    if (self.libraryWindow.layoutWindow.l.drawing.mutexChangeGuiTryLock()):
        self.libraryWindow.layoutWindow.l.drawing.openView( self.libname,self.cellname,newItem.text())
	self.libraryWindow.layoutWindow.l.drawing.mutexChangeUnlock()
	self.libraryWindow.layoutWindow.l.filename=self.libname+".oa"
	self.libraryWindow.layoutWindow.l.setWindowTitle( self.libraryWindow.layoutWindow.l.filename )
	self.libraryWindow.layoutWindow.l.drawing.paint()

#################################################################################
#
# schematic handler for les
#
#################################################################################

class lesHandler(QtGui.QWidget):
  def __init__(self,libraryWindow):
    QtGui.QWidget.__init__(self)
    fileTypes['les']='Schematic'
    fileTypes['LES']='Schematic'
    fileIcons['Schematic']=QtGui.QIcon(":/icons/netlisticon.png")
    fileWidget['Schematic']=self
    self.visible=False
    self.libraryWindow=libraryWindow
    hLayout = QtGui.QHBoxLayout(self)
    self.cellList = QtGui.QListWidget(self)
    self.cellList.currentItemChanged.connect(self.cellSelected)
    hLayout.addWidget(self.cellList)
    hLayout.setContentsMargins(0,0,0,0)
    libraryWindow.stackedWidget.addWidget(self)

  def setFile(self,libraryWindow,fileinfo):
    self.visible=True
    if libraryWindow.schematicWindow.schematicClose==True:
       libraryWindow.schematicWindow.openSchematic()
    if libraryWindow.schematicWindow.s.drawing.modified():
	import random;
	r=random.random()
	pyLayoutNewWin[r] = libraryWindow.layoutWindow
	libraryWindow.schematicWindow = layoutWindow("schematic")
    self.schematicWindow=libraryWindow.schematicWindow
    libraryWindow.schematicWindow.s.show()
    for i in range(30):
      libraryWindow.schematicWindow.s.drawing.deleteCurrentSheet()
    try:
      self.schematicWindow.s.sheetsChanged.disconnect(self.setSheetList)
    except:
      #do nothing
      egal=1
    self.schematicWindow.s.sheetsChanged.connect(self.setSheetList)
    libraryWindow.stackedWidget.setCurrentWidget(self)
    libraryWindow.schematicWindow.s.open(fileinfo.filePath())
    libraryWindow.schematicWindow.s.drawing.setModifySaved()

  def unsetFile(self,libraryWindow):
    self.visible=False
    if libraryWindow.schematicWindow.schematicClose!=True:
      self.schematicWindow.s.sheetsChanged.disconnect(self.setSheetList)
      if libraryWindow.schematicWindow.s.drawing.modified()!=True:
	libraryWindow.schematicWindow.s.hide()

  def setSheetList(self,cl,cc):
    if self.schematicWindow.schematicClose:
	return;
    self.cellList.clear()
    self.cellList.addItems(cl)
    self.setCurrentSheet(cc)
   

  def setCurrentSheet(self,name):
    if self.schematicWindow.schematicClose:
	return;
    il=self.cellList.findItems(name,QtCore.Qt.MatchExactly)
    if len(il)>0:
      self.cellList.setCurrentItem(il[0])

  def cellSelected(self,newItem,oldItem):
    if newItem==None:
      return
    if self.schematicWindow.schematicClose:
	return;
    if self.schematicWindow.s.drawing.currentSheet.sheetName == newItem.text():
       return
    if self.schematicWindow.s.drawing.mutexReadTryLock():
	  self.schematicWindow.s.drawing.setSheet(newItem.text())
          self.schematicWindow.s.drawing.mutexReadUnlock();

#################################################################################
#
# layout handler for gds,oasis,cif,dxf
#
#################################################################################


class gdsHandler(QtGui.QWidget):
  '''
  Handles file format for GDSII, OASIS, DXF and CIF
  '''
  def __init__(self,libraryWindow):
    QtGui.QWidget.__init__(self)
    fileTypes['gds']='Layout GDSII'
    fileTypes['GDS']='Layout GDSII'
    fileTypes['gds.gz']='Layout GDSII'
    fileTypes['GDS.gz']='Layout GDSII'
    fileIcons['Layout GDSII']=QtGui.QIcon(":/icons/layoutfull.png")
    fileWidget['Layout GDSII']=self
    fileTypes['oas']='Layout OASIS'
    fileTypes['OAS']='Layout OASIS'
    fileTypes['oasis']='Layout OASIS'
    fileTypes['OASIS']='Layout OASIS'
    fileTypes['oas.gz']='Layout OASIS'
    fileTypes['OAS.gz']='Layout OASIS'
    fileIcons['Layout OASIS']=QtGui.QIcon(":/icons/layoutfull.png")
    fileWidget['Layout OASIS']=self
    fileTypes['cif']='Layout CIF'
    fileTypes['CIF']='Layout CIF'
    fileIcons['Layout CIF']=QtGui.QIcon(":/icons/layoutreduced.png")
    fileWidget['Layout CIF']=self
    fileTypes['dxf']='Layout DXF'
    fileTypes['DXF']='Layout DXF'
    fileIcons['Layout DXF']=QtGui.QIcon(":/icons/layoutreduced.png")
    fileWidget['Layout DXF']=self
    self.visible=False
    self.libraryWindow=libraryWindow
    hLayout = QtGui.QHBoxLayout(self)
    self.cellList = QtGui.QListWidget(self)
    self.cellList.currentItemChanged.connect(self.cellSelected)
    hLayout.addWidget(self.cellList)
    hLayout.setContentsMargins(0,0,0,0)
    vLayout=QtGui.QVBoxLayout()
    fLayout=QtGui.QFormLayout()
    fLayout.setFormAlignment(QtCore.Qt.AlignHCenter|QtCore.Qt.AlignTop)
    self.form={}
    for i in range(20):
      self.form[i] =  QtGui.QLabel(self)
      self.form[i].setText("file name:")
      if i%2==0:
	fLayout.setWidget(i/2, QtGui.QFormLayout.LabelRole, self.form[i])
      else:
        fLayout.setWidget(i/2, QtGui.QFormLayout.FieldRole, self.form[i])
    vLayout.addLayout(fLayout)
    vSpacer=QtGui.QSpacerItem(20,207,QtGui.QSizePolicy.Minimum, QtGui.QSizePolicy.Expanding)
    vLayout.addItem(vSpacer)
    hLayout.addLayout(vLayout)
    libraryWindow.stackedWidget.addWidget(self)

  def setFile(self,libraryWindow,fileinfo):
    self.visible=True
    if libraryWindow.layoutWindow.layoutClose==True:
       libraryWindow.layoutWindow.openLayout("layoutFull")
    if libraryWindow.layoutWindow.l.drawing.modified():
	import random;
	r=random.random()
	pyLayoutNewWin[r] = libraryWindow.layoutWindow
	libraryWindow.layoutWindow = layoutWindow("layoutFull") 
    self.layoutWindow=libraryWindow.layoutWindow
    self.fileType=libraryWindow.typeProvider.type(fileinfo)
    for i in range(20):
      self.form[i].setText("")
    self.form[0].setText("file name:")
    self.form[1].setText(fileinfo.baseName())
    self.form[2].setText("size:")
    s=QtCore.QString()
    s.setNum(fileinfo.size())
    self.form[3].setText(s+" bytes")
    self.cellList.clear()
    try:
      self.layoutWindow.l.cellsChanged.disconnect(self.setCellList)
    except:
      #do nothing
      egal=1
    self.layoutWindow.l.cellsChanged.connect(self.setCellList)
    libraryWindow.stackedWidget.setCurrentWidget(self)
    libraryWindow.layoutWindow.l.show()
    libraryWindow.layoutWindow.l.open(fileinfo.filePath())
    self.setFileInfo=False

  def unsetFile(self,libraryWindow):
    self.visible=False
    if libraryWindow.layoutWindow.layoutClose!=True:
      self.layoutWindow.l.cellsChanged.disconnect(self.setCellList)
      if libraryWindow.layoutWindow.l.drawing.modified()!=True:
	libraryWindow.layoutWindow.l.hide()

  def setCellList(self,cl,cc):
    if self.layoutWindow.layoutClose:
	return;
    self.cellList.clear()
    self.cellList.addItems(cl)
    self.setCurrentCell(cc)
    if self.setFileInfo==False:
       self.setFileInfo=True
       self.form[4].setText("type:")
       self.form[5].setText(self.layoutWindow.l.drawing.fileType)
       if self.fileType=='Layout GDSII':
	self.form[6].setText("lib name:")
	self.form[7].setText(self.layoutWindow.l.drawing.libname)
       else:
	self.form[6].setText("")
	self.form[7].setText("")

  def setCurrentCell(self,name):
    if self.layoutWindow.layoutClose:
	return;
    il=self.cellList.findItems(name,QtCore.Qt.MatchExactly)
    if len(il)>0:
      self.cellList.setCurrentItem(il[0])


  def cellSelected(self,newItem,oldItem):
    if newItem==None:
      return
    if self.layoutWindow.layoutClose:
	return;
    if self.layoutWindow.l.drawing.currentCell.cellName == newItem.text():
       return;
    if self.layoutWindow.l.drawing.mutexReadTryLock():
	  self.layoutWindow.l.drawing.setCell(newItem.text())
          self.layoutWindow.l.drawing.mutexReadUnlock()
	  self.layoutWindow.l.setCellCombo(newItem.text())
    #self.libraryWindow.l.guiUpdate()

#################################################################################
#
# main window
#
#################################################################################

class libraryManagerWindow(QtGui.QMainWindow):
  def __init__(self):
    pixmap = QtGui.QPixmap(":/splash")
    splashscreen = pylayout.splash(pixmap)
    splashscreen.show()
    QtGui.QMainWindow.__init__(self)
    self.setWindowTitle("juspertor library manager")
    self.setWindowIcon(QtGui.QIcon(":/icons/layoutfull.png"))
    self.centralWidget = QtGui.QWidget(self)
    self.horizontalLayout = QtGui.QHBoxLayout(self.centralWidget)
    self.splitter = QtGui.QSplitter(self.centralWidget)
    self.splitter.setOrientation(QtCore.Qt.Horizontal)
    self.fileModel=QtGui.QFileSystemModel(self)
    self.fileModel.setRootPath("/")
    self.typeProvider=iconProvider()
    self.fileModel.setIconProvider(self.typeProvider)
    self.fileModel.setReadOnly(False)
    self.fileTree=QtGui.QTreeView(self.splitter)
    self.fileTree.setModel(self.fileModel); 
    self.fileTree.setAnimated(True)
    self.fileTree.setIndentation(20)
    self.fileTree.setSortingEnabled(True)
    self.fileTree.sortByColumn(0,QtCore.Qt.AscendingOrder)
    self.fileTree.setColumnWidth(0,250)
    self.fileTree.setColumnWidth(1,70)
    self.stackedWidget = QtGui.QStackedWidget(self.splitter)
    self.defaultPage = QtGui.QWidget()
    verticalLayout = QtGui.QVBoxLayout(self.defaultPage)
    formLayout =  QtGui.QFormLayout()
    formLayout.setFormAlignment(QtCore.Qt.AlignHCenter|QtCore.Qt.AlignTop)
    label1 =  QtGui.QLabel(self.defaultPage)
    label1.setObjectName("label_filename")
    label1.setText("file name:")
    formLayout.setWidget(0, QtGui.QFormLayout.LabelRole, label1)
    self.defaultFilename =  QtGui.QLabel(self.defaultPage)
    formLayout.setWidget(0, QtGui.QFormLayout.FieldRole, self.defaultFilename)
    label2 =  QtGui.QLabel(self.defaultPage)
    label2.setText("type:")
    formLayout.setWidget(1, QtGui.QFormLayout.LabelRole, label2)
    self.defaultType =  QtGui.QLabel(self.defaultPage)
    self.defaultType.setText("unknown")
    formLayout.setWidget(1, QtGui.QFormLayout.FieldRole, self.defaultType)
    label4 =  QtGui.QLabel(self.defaultPage)
    label4.setText( "size:")
    formLayout.setWidget(2, QtGui.QFormLayout.LabelRole, label4);
    self.defaultSize = QtGui.QLabel(self.defaultPage)
    self.defaultSize.setText("-")
    formLayout.setWidget(2, QtGui.QFormLayout.FieldRole, self.defaultSize)
    label5 =  QtGui.QLabel(self.defaultPage)
    label5.setText("last modified:")
    formLayout.setWidget(3, QtGui.QFormLayout.LabelRole, label5)
    self.defaultModified =  QtGui.QLabel(self.defaultPage)
    self.defaultModified.setObjectName("modified")
    self.defaultModified.setText("-")
    formLayout.setWidget(3, QtGui.QFormLayout.FieldRole,self.defaultModified)
    verticalLayout.addLayout(formLayout)
    verticalSpacer = QtGui.QSpacerItem(20, 207, QtGui.QSizePolicy.Minimum, QtGui.QSizePolicy.Expanding)
    verticalLayout.addItem(verticalSpacer);

    self.stackedWidget.addWidget(self.defaultPage)
    self.splitter.addWidget(self.stackedWidget)
    self.horizontalLayout.addWidget(self.splitter)
    self.setCentralWidget(self.centralWidget)
    self.currentWidget=""
    self.currentFile=""
    self.gds=gdsHandler(self)
    self.les=lesHandler(self)
    if pylayout.oaInfo.openAccess():
       self.oa=oaHandler(self);
       self.noOa=False;
    else:
       self.noOa=True;
    self.stackedWidget.setCurrentWidget(self.defaultPage)
    size=[560,440]
    self.splitter.setSizes(size)
    self.resize(1000, 550)
    self.fileTree.activated.connect(self.fileChanged)
    #self.fileTree.entered.connect(self.fileChanged)
    self.fileTree.clicked.connect(self.fileChanged)

    self.layoutWindow=layoutWindow("layoutFull")
    self.schematicWindow=layoutWindow("schematic")
    #splashscreen.finish(self)
    self.show()

  def fileChanged(self, modelindex):
    fileinfo=self.fileModel.fileInfo(modelindex)
    filetype=self.typeProvider.type(fileinfo)
    if self.currentFile==fileinfo.filePath():
	return
    self.currentFile=fileinfo.filePath()
    if (filetype!=self.currentWidget):
       if self.currentWidget!="":
	  if fileWidget.has_key(filetype):
	    if fileWidget[self.currentWidget]!=fileWidget[filetype]:
	      fileWidget[self.currentWidget].unsetFile(self)
	  else:
	      fileWidget[self.currentWidget].unsetFile(self)
    if fileWidget.has_key(filetype):
      self.currentWidget=filetype
      fileWidget[self.currentWidget].setFile(self,fileinfo)
    else:
      self.currentWidget=""
      self.stackedWidget.setCurrentWidget(self.defaultPage)
      self.defaultFilename.setText(fileinfo.baseName())
      s=QtCore.QString()
      s.setNum(fileinfo.size())
      self.defaultSize.setText(s+" bytes")
      s=QtCore.QDateTime(fileinfo.lastModified()).toString()
      self.defaultModified.setText(s)
      self.defaultType.setText("unknown")
      if fileinfo.isDir():
	  self.defaultType.setText("Folder")
      if fileinfo.isSymLink():
	  self.defaultType.setText("Link")

#################################################################################
#
# main programm
#
#################################################################################

if (QtGui.QApplication.instance()==None):
    '''
    Please uncomment the following line if you get an error starting this 
    python file on Linux with an error:
    [xcb] Unknown request in queue while dequeuing
    [xcb] Most likely this is a multi-threaded client and XInitThreads has not been called
    [xcb] Aborting, sorry about that.
    It will work on Qt >= 4.8.0. There is no fix for this bug in qt/pyqt for Qt < 4.8.0
    '''
    #QtGui.QApplication.setAttribute(QtCore.Qt.AA_X11InitThreads)
    #if (QtCore.QString(QtCore.qVersion())>QtCore.QString("4.7.4")):
    #  QtGui.QApplication.setAttribute(QtCore.Qt.AA_X11InitThreads)
    globalApp=QtGui.QApplication(sys.argv)

if __name__ == '__main__':

    win = libraryManagerWindow()
    #win2 = layoutWindow()
    sys.exit(QtGui.QApplication.instance().exec_())



